
unit RangeValidationU;

interface

uses
  Windows, Messages, SysUtils, Classes, HTTPApp, WebModu, HTTPProd, ReqMulti,
  WebDisp, WebAdapt, WebComp, CompProd, PagItems, SiteProd,
  cvWebComponents, MidItems, WebForm;

type
  TRangeValidation = class(TWebAppPageModule)
    AdapterPageProducer: TAdapterPageProducer;
    WebAppComponents: TWebAppComponents;
    ApplicationAdapter: TApplicationAdapter;
    PageDispatcher: TPageDispatcher;
    AdapterDispatcher: TAdapterDispatcher;
    Adapter: TAdapter;
    IntegerValue: TAdapterField;
    Date: TAdapterField;
    StringValue: TAdapterField;
    Validate: TAdapterAction;
    IntegerValueRange: TAdapterField;
    DateRange: TAdapterField;
    StringValueRange: TAdapterField;
    cvAdapterForm: TcvAdapterForm;
    AdapterFieldGroup1: TAdapterFieldGroup;
    AdapterCommandGroup1: TAdapterCommandGroup;
    LayoutGroup: TLayoutGroup;
    IntegerValueRangeDisplayField: TAdapterDisplayField;
    IntegerValueDisplayField: TcvAdapterDisplayField;
    DateDisplayField: TcvAdapterDisplayField;
    DateRangeDisplayField: TAdapterDisplayField;
    StringValueDisplayField: TcvAdapterDisplayField;
    StringValueRangeDisplayField: TAdapterDisplayField;
    IntegerValueRangeValidator: TcvRangeValidator;
    DateRangeValidator: TcvRangeValidator;
    StringValueRangeValidator: TcvRangeValidator;
    procedure IntegerValueRangeGetValue(Sender: TObject;
      var Value: Variant);
    procedure DateRangeGetValue(Sender: TObject; var Value: Variant);
    procedure StringValueRangeGetValue(Sender: TObject;
      var Value: Variant);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  function RangeValidation: TRangeValidation;

implementation

{$R *.dfm}  {*.html}

uses WebReq, WebCntxt, WebFact, Variants;

function RangeValidation: TRangeValidation;
begin
  Result := TRangeValidation(WebContext.FindModuleClass(TRangeValidation));
end;

procedure TRangeValidation.IntegerValueRangeGetValue(Sender: TObject;
  var Value: Variant);
begin
 Value :=
  'Min(' + IntegerValueRangeValidator.MinimumValue +
  '), Max(' + IntegerValueRangeValidator.MaximumValue + ')';
end;

procedure TRangeValidation.DateRangeGetValue(Sender: TObject;
  var Value: Variant);
begin
 Value :=
  'Min(' + DateRangeValidator.MinimumValue +
  '), Max(' + DateRangeValidator.MaximumValue + ')';
end;

procedure TRangeValidation.StringValueRangeGetValue(Sender: TObject;
  var Value: Variant);
begin
 Value :=
  'Min(' + StringValueRangeValidator.MinimumValue +
  '), Max(' + StringValueRangeValidator.MaximumValue + ')';
end;

initialization
  if WebRequestHandler <> nil then
    WebRequestHandler.AddWebModuleFactory(TWebAppPageModuleFactory.Create(TRangeValidation, TWebPageInfo.Create([wpPublished {, wpLoginRequired}], '.html'), caCache));

end.
