unit RegularExpressionEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DesignIntf, DesignEditors, ComCtrls, StdCtrls, Buttons, ExtCtrls;

type
  TRegularExpressionEditor = class(TStringProperty)
  private
  protected
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

  TRegularExpressionEditorForm = class(TForm)
    ButtonsPanel: TPanel;
    btnOK: TBitBtn;
    btnCancel: TBitBtn;
    Panel1: TPanel;
    Label1: TLabel;
    RegularExpressionEdit: TEdit;
    Panel2: TPanel;
    Label2: TLabel;
    SampleRegularExpressionsList: TListView;
    procedure SampleRegularExpressionsListSelectItem(Sender: TObject;
      Item: TListItem; Selected: Boolean);
  private
    { Private declarations }
    procedure InitializeSampleRegularExpressionsList;
  public
    { Public declarations }
  end;


implementation

{$R *.dfm}

type
 TSampleExpressionRec = record
  Title,Expression,Example: string;
 end;

const
 NumberSampleExpressions = 6;
var
 SampleExpressionsArr: array[0..NumberSampleExpressions-1] of TSampleExpressionRec =
 (
   (Title: 'Phone'; Expression: '^(\d{3})\d{3}-\d{4}$'; Example: '(415)555-1212';),
   (Title: 'EMail'; Expression: '^[\w\.-]+@[\w\.-]+\.[a-zA-Z]+$'; Example: 'someone@borland.com';),
   (Title: 'Social security number'; Expression: '^\d{3}-\d{2}-\d{4}$'; Example: '555-55-5555';),
   (Title: 'US or Canadian postal code';Expression: '^(\d{5}(( |-)\d{4})?)|([A-Za-z]\d[A-Za-z]( |-)\d[A-Za-z]\d)$'; Example: '55555-5555';),
   (Title: 'Zip Code'; Expression: '^\d{5}$'; Example: '90504';),
   (Title: 'Date'; Expression: '^\d/{2}\d{2}/\d{2}$'; Example: '06/27/94';)
 );

function TRegularExpressionEditor.GetAttributes: TPropertyAttributes;
begin
 Result := [paDialog, paRevertable];
end;

procedure TRegularExpressionEditor.Edit;
begin
 with TRegularExpressionEditorForm.Create(nil) do
  begin
   try
    InitializeSampleRegularExpressionsList;
    RegularExpressionEdit.Text := GetValue;
    if ShowModal = mrOK then SetValue(Trim(RegularExpressionEdit.Text));
   finally
    Release;
   end;
  end;
end;

procedure TRegularExpressionEditorForm.InitializeSampleRegularExpressionsList;
var
 ListItem: TListItem;
 SampleExpressionRec: TSampleExpressionRec;
 i: Integer;
begin
 SampleRegularExpressionsList.Items.BeginUpdate;
 try
  SampleRegularExpressionsList.Items.Clear;
  for i := 0 to NumberSampleExpressions-1 do
   begin
    SampleExpressionRec := SampleExpressionsArr[i];
    ListItem := SampleRegularExpressionsList.Items.Add;
    ListItem.Caption := SampleExpressionRec.Title;
    ListItem.SubItems.Add(SampleExpressionRec.Expression);
    ListItem.SubItems.Add(SampleExpressionRec.Example);
   end;
 finally
  SampleRegularExpressionsList.Items.EndUpdate;
 end;
end;

procedure TRegularExpressionEditorForm.SampleRegularExpressionsListSelectItem(
  Sender: TObject; Item: TListItem; Selected: Boolean);
begin
 if Selected then RegularExpressionEdit.Text := Item.SubItems[0];
end;

end.
